SystemOrganization addCategory: #'ProcessWrapper-Core-Tests'!
SystemOrganization addCategory: #'ProcessWrapper-Core'!

Object subclass: #ProcessWrapper
	instanceVariableNames: 'processPointer useStdout useStderr stdoutSemaphore stderrSemaphore stdoutQueue stderrQueue'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'ProcessWrapper-Core'!

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
closeStderr: anExternalProcessPointer

	<primitive: 'primitiveCloseStderr' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
closeStdin: anExternalProcessPointer

	<primitive: 'primitiveCloseStdin' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
closeStdout: anExternalProcessPointer

	<primitive: 'primitiveCloseStdout' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'plugin handling' stamp: 'ul 7/16/2007 23:47'!
downloadPlugin

	Utilities informUserDuring: [ :bar |
		| document |
		bar value: 'Downloading plugin'.
		document := 'http://people.inf.elte.hu/uzonyile/ProcessWrapper/ProcessWrapperPlugin.dll' asUrl retrieveContents.
		bar value: 'Saving plugin'.
		(FileDirectory default fileNamed: self pluginName, '.dll')
			binary;
			nextPutAll: document content;
			close ]

! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
exitCode: anExternalProcessPointer

	<primitive: 'primitiveExitCode' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'finalization' stamp: 'ul 7/15/2007 20:06'!
finalizationRegistry

	^Registry ifNil: [
		WeakArray isFinalizationSupported ifFalse:[ ^nil ].
		Registry := WeakRegistry new ]
! !

!ProcessWrapper class methodsFor: 'plugin handling' stamp: 'ul 7/16/2007 23:42'!
initialize

	super initialize.
	(FileDirectory default fileExists: self pluginName, '.dll') ifTrue: [ ^self ].
	(self confirm: 'Seems like you''re missing the plugin for ProcessWrapper. Would you like to download it now?')
		ifTrue: [ self downloadPlugin ]
		
! !

!ProcessWrapper class methodsFor: 'plugin handling' stamp: 'ul 7/15/2007 22:29'!
isPluginLoaded

	^SmalltalkImage current listLoadedModules anySatisfy: [ :each |
		each beginsWith: self pluginName ]
! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
isRunning: anExternalProcessPointer

	<primitive: 'primitiveIsRunning' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
logLevelDebug

	<primitive: 'primitiveLogLevelDebug' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
logLevelError

	<primitive: 'primitiveLogLevelError' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
logLevelInfo

	<primitive: 'primitiveLogLevelInfo' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
logLevelNone

	<primitive: 'primitiveLogLevelNone' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
logTest

	<primitive: 'primitiveLogTest' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'instance creation' stamp: 'ul 7/15/2007 13:42'!
new

	^super new
		processPointer: self newProcess;
		registerForFinalization;
		yourself.

	! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
newProcess

	<primitive: 'primitiveNewProcess' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'plugin handling' stamp: 'ul 7/15/2007 11:36'!
pluginName
	
	^'ProcessWrapperPlugin'! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
readFromStderr: anExternalProcessPointer into: aByteArray size: anInteger

	<primitive: 'primitiveReadFromStderrIntoSize' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
readFromStdout: anExternalProcessPointer into: aByteArray size: anInteger

	<primitive: 'primitiveReadFromStdoutIntoSize' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'finalization' stamp: 'ul 7/15/2007 22:31'!
registerForFinalization: aProcessWrapper

	self finalizationRegistry add: aProcessWrapper 
! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
removeProcess: anExternalProcessPointer

	<primitive: 'primitiveRemoveProcess' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
setStderrSemaphore: aSemaphoreIndex for: anExternalProcessPointer

	<primitive: 'primitiveSetStderrSemaphoreFor' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
setStdoutSemaphore: aSemaphoreIndex for: anExternalProcessPointer

	<primitive: 'primitiveSetStdoutSemaphoreFor' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
showWindowAtStartup: anExternalProcessPointer

	<primitive: 'primitiveShowWindowAtStartup' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
startProcess: anExternalProcessPointer withCommandLine: aString

	<primitive: 'primitiveStartProcessWithCommandLine' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
terminate: anExternalProcessPointer

	<primitive: 'primitiveTerminate' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'plugin handling' stamp: 'ul 7/15/2007 22:28'!
unloadPlugin

	Smalltalk garbageCollect.
	Smalltalk garbageCollect.	"To remove the executors"
	self allInstances size isZero ifFalse: [ ^self error: 'ProcessWrapper instances hanging!!'].
	SmalltalkImage current unloadModule: self pluginName! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
waitForExit: anExternalProcessPointer for: timeoutMilliseconds

	<primitive: 'primitiveWaitForExitFor' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper class methodsFor: 'primitive calls' stamp: 'ul 7/18/2007 22:35'!
writeToStdin: anExternalProcessPointer message: aByteArray length: anInteger

	<primitive: 'primitiveWriteToStdinMessageLength' module: 'ProcessWrapperPlugin'>
	self primitiveFailed! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/18/2007 21:04'!
closeStderr

	^self class closeStderr: processPointer ! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/15/2007 23:26'!
closeStdin

	^self class closeStdin: processPointer ! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/18/2007 21:04'!
closeStdout

	^self class closeStdout: processPointer ! !

!ProcessWrapper methodsFor: 'runtime information' stamp: 'ul 7/14/2007 22:04'!
exitCode

	^self class exitCode: processPointer ! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/15/2007 21:00'!
finalize

	processPointer ifNotNil: [
		self class removeProcess: processPointer ].
	stdoutSemaphore ifNotNil: [
		stdoutSemaphore terminateProcess.
		Smalltalk unregisterExternalObject: stdoutSemaphore ].
	stderrSemaphore ifNotNil: [
		stderrSemaphore terminateProcess.
		Smalltalk unregisterExternalObject: stderrSemaphore ].

	
! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/15/2007 20:29'!
initialize

	useStdout := false.
	useStderr := false

	
! !

!ProcessWrapper methodsFor: 'runtime information' stamp: 'ul 7/14/2007 22:04'!
isRunning

	^self class isRunning: processPointer ! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/17/2007 18:29'!
prepareStderr

	| semaphoreIndex |
	useStderr ifFalse: [ ^self ].
	stderrSemaphore := Semaphore new.
	semaphoreIndex := Smalltalk registerExternalObject: stderrSemaphore.
	self class setStderrSemaphore: semaphoreIndex for: processPointer.
	stderrQueue := SharedQueue new.
	self spawnReaderProcessWith: stderrSemaphore queue: stderrQueue dataSource: [ :buffer |
		self class readFromStderr: processPointer into: buffer size: buffer size ]! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/17/2007 14:07'!
prepareStdout

	| semaphoreIndex |
	useStdout ifFalse: [ ^self ].
	stdoutSemaphore := Semaphore new.
	semaphoreIndex := Smalltalk registerExternalObject: stdoutSemaphore.
	self class setStdoutSemaphore: semaphoreIndex for: processPointer.
	stdoutQueue := SharedQueue new.
	self spawnReaderProcessWith: stdoutSemaphore queue: stdoutQueue dataSource: [ :buffer |
		self class readFromStdout: processPointer into: buffer size: buffer size ]! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/14/2007 21:54'!
processPointer: aSmallInteger

	processPointer ifNil: [ processPointer := aSmallInteger ]! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/15/2007 14:30'!
readFromStderr
	
	^stderrQueue next! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/15/2007 14:31'!
readFromStderrNoWait
	
	^stderrQueue nextOrNil! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/14/2007 23:13'!
readFromStdout
	
	^stdoutQueue next! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/15/2007 00:56'!
readFromStdoutNoWait
	
	^stdoutQueue nextOrNil! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/15/2007 22:32'!
registerForFinalization
	
	self class registerForFinalization: self! !

!ProcessWrapper methodsFor: 'pre-start options' stamp: 'ul 7/14/2007 23:28'!
showWindowAtStartup

	^self class showWindowAtStartup: processPointer ! !

!ProcessWrapper methodsFor: 'private' stamp: 'ul 7/18/2007 22:36'!
spawnReaderProcessWith: aSemaphore queue: aSharedQueue dataSource: aBlock
	[ 
		| buffer bytesRead shouldRun |
		buffer := ByteArray new: 4096. 
		shouldRun := true.
		[ shouldRun ] whileTrue: [
			aSemaphore wait.
			bytesRead := aBlock value: buffer.
			bytesRead > buffer size "Pipe is closed, no more data available."
				ifTrue: [ shouldRun := false ]
				ifFalse: [
					bytesRead isZero
						ifFalse: [ aSharedQueue nextPut: (buffer first: bytesRead) ] ] ] ] fork! !

!ProcessWrapper methodsFor: 'start-stop' stamp: 'ul 7/16/2007 18:53'!
startWithCommand: aStringOrByteArray
	
	| input |
	useStdout | useStderr ifTrue: [ 
		self 
			prepareStdout;
			prepareStderr;
			registerForFinalization ].
	input := aStringOrByteArray asByteArray.
	input last = 0 ifFalse: [ input := input copyWith: 0 ].
	^self class startProcess: processPointer  withCommandLine: input! !

!ProcessWrapper methodsFor: 'start-stop' stamp: 'ul 7/15/2007 22:19'!
startWithShellCommand: aStringOrByteArray

	^self startWithCommand: 'cmd.exe /C ' asByteArray, aStringOrByteArray asByteArray! !

!ProcessWrapper methodsFor: 'start-stop' stamp: 'ul 7/14/2007 23:29'!
terminate

	^self class terminate: processPointer ! !

!ProcessWrapper methodsFor: 'pre-start options' stamp: 'ul 7/15/2007 20:29'!
useStderr

	useStderr := true! !

!ProcessWrapper methodsFor: 'pre-start options' stamp: 'ul 7/15/2007 20:29'!
useStdout

	useStdout := true! !

!ProcessWrapper methodsFor: 'start-stop' stamp: 'ul 7/15/2007 00:00'!
waitForExitFor: timeoutMilliseconds

	^self class waitForExit: processPointer for: timeoutMilliseconds ! !

!ProcessWrapper methodsFor: 'input-output handling' stamp: 'ul 7/14/2007 23:33'!
writeToStdin: aByteArray

	^self class writeToStdin:  processPointer message:  aByteArray length: aByteArray size! !

TestCase subclass: #ProcessWrapperClassTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProcessWrapper-Core-Tests'!

!ProcessWrapperClassTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:08'!
testPluginLoading
	"Fails with an error if there are references to ProcessWrapper instances."

	ProcessWrapper unloadPlugin.
	self shouldnt: (ProcessWrapper isPluginLoaded).
	ProcessWrapper new.
	self should: (ProcessWrapper isPluginLoaded).! !

TestCase subclass: #ProcessWrapperTests
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProcessWrapper-Core-Tests'!

ProcessWrapperTests subclass: #ProcessWrapperCommandShellTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProcessWrapper-Core-Tests'!

!ProcessWrapperCommandShellTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:03'!
testCopy

	self shouldnt: (FileDirectory default fileExists: 'foo1.txt').
	self shouldnt: (FileDirectory default fileExists: 'foo2.txt').
	(FileDirectory default fileNamed: 'foo1.txt') close.
	self should: (process startWithShellCommand: 'copy foo1.txt foo2.txt').
	self should: (process waitForExitFor: 5000).
	self shouldnt: process isRunning.
	self should: process exitCode isZero.
	self should: (FileDirectory default fileExists: 'foo1.txt').
	self should: (FileDirectory default fileExists: 'foo2.txt').
	FileDirectory default
		deleteFileNamed: 'foo1.txt';
		deleteFileNamed: 'foo2.txt'.! !

!ProcessWrapperCommandShellTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:03'!
testDelete

	self shouldnt: (FileDirectory default fileExists: 'foo1.txt').
	(FileDirectory default fileNamed: 'foo1.txt') close.
	self should: (process startWithShellCommand: 'del foo1.txt').
	self should: (process waitForExitFor: 5000).
	self shouldnt: (FileDirectory default fileExists: 'foo1.txt').
	FileDirectory default deleteFileNamed: 'foo1.txt'! !

!ProcessWrapperCommandShellTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:03'!
testEcho

	process useStdout.
	self should: (process startWithShellCommand: 'echo blabla').
	self should: (process readFromStdout asString = ('blabla', String crlf))! !

!ProcessWrapperCommandShellTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:04'!
testMove

	(FileDirectory default fileNamed: 'foo1.txt') close.
	process startWithCommand: 'cmd.exe /C move foo1.txt foo2.txt'.
	process waitForExitFor: 1000.
	self shouldnt: (FileDirectory default fileExists: 'foo1.txt').
	self should: (FileDirectory default fileExists: 'foo2.txt').
	FileDirectory default
		deleteFileNamed: 'foo1.txt';
		deleteFileNamed: 'foo2.txt'.! !

!ProcessWrapperCommandShellTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:04'!
testType

	self shouldnt: (FileDirectory default fileExists: 'foo1.txt').
	(FileDirectory default fileNamed: 'foo1.txt')
		nextPutAll: 'blabla';
		close.
	process useStdout.
	self should: (process startWithShellCommand: 'type foo1.txt').
	self should: (process waitForExitFor: 5000).
	self shouldnt: process isRunning.
	self should: process exitCode isZero.
	self should: (process readFromStdout asString = 'blabla').
	FileDirectory default
		deleteFileNamed: 'foo1.txt'! !

ProcessWrapperTests subclass: #ProcessWrapperOpeningWindowTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProcessWrapper-Core-Tests'!

!ProcessWrapperOpeningWindowTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:03'!
testExplorer

	"open an explorer window to the default directory"
	self should: process showWindowAtStartup.
	self should: (process startWithCommand: 'explorer .').
	self should: (process waitForExitFor: 5000).
	self shouldnt: process isRunning.
	self should: process exitCode isZero.
	! !

!ProcessWrapperTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:02'!
setUp

	process := ProcessWrapper new! !

!ProcessWrapperTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:08'!
tearDown

	process isRunning ifTrue: [
		process terminate ].
	process := nil "Release the ProcessWrappers for successful plugin unloading"
	! !

ProcessWrapperTests subclass: #ProcessWrapperUnixUtilsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProcessWrapper-Core-Tests'!

!ProcessWrapperUnixUtilsTests commentStamp: '<historical>' prior: 0!
To run these tests you'll need the unixutils suit.!

!ProcessWrapperUnixUtilsTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:03'!
testCat

	process useStdout.
	self should: (process startWithCommand: 'cat').
	self should: (process isRunning).
	self shouldnt: (process waitForExitFor: 5000).
	self should: (process writeToStdin: 'bla').
	self should: process isRunning.
	self should: (process readFromStdout asString = 'bla').
	self should: (process closeStdin).
	self should: (process waitForExitFor: 5000).
	self shouldnt: process isRunning.
	self should: process exitCode isZero.
	! !

!ProcessWrapperUnixUtilsTests methodsFor: 'as yet unclassified' stamp: 'ul 7/16/2007 13:03'!
testTouch

	self shouldnt: (FileDirectory default fileExists: 'ProcessWrapperTest.bla').	
	self should: (process startWithCommand: 'touch ProcessWrapperTest.bla').
	self should: (process waitForExitFor: 5000).
	self shouldnt: process isRunning.
	self should: process exitCode isZero.
	self should: (FileDirectory default fileExists: 'ProcessWrapperTest.bla').
	FileDirectory default deleteFileNamed: 'ProcessWrapperTest.bla' 
	! !
ProcessWrapper initialize!
